# NNabla Tutorial

NNabla's tutorials are provided as [Jupyter Notebooks](http://jupyter.org/)
where you can run the code step-by-step.

On many Linux (probably on Windows), Jupyter can be easily installed using pip by:

```shell
pip install ipython<=5  # IPython>=6 is not supported in Python<=3.3.
pip install jupyter
```


You can run Jupyter server on your terminal on this folder.

```shell
jupyter notebook
```

Then, follow the instruction printed on your terminal to connect the server
on your browser.

Open the `.ipynb` files to start tutorials.


You can also run it directly on [Colab](https://colab.research.google.com/) from the links in the table below.


| Name        | Notebook           | Doc  |
|:------------------------------------------------:|:-------------:|:-----:|
| NNabla By Examples      | [![Open In Colab](https://colab.research.google.com/assets/colab-badge.svg)](https://colab.research.google.com/github/sony/nnabla/blob/master/tutorial/by_examples.ipynb) | [read](https://nnabla.readthedocs.io/en/latest/python/tutorial/by_examples.html) |
| NNabla Python API     | [![Open In Colab](https://colab.research.google.com/assets/colab-badge.svg)](https://colab.research.google.com/github/sony/nnabla/blob/master/tutorial/python_api.ipynb) | [read](https://nnabla.readthedocs.io/en/latest/python/tutorial/python_api.html) |
| Cifar-10 Training     | [![Open In Colab](https://colab.research.google.com/assets/colab-badge.svg)](https://colab.research.google.com/github/sony/nnabla/blob/master/tutorial/cifar10_classification.ipynb) | Coming Soon |
| Model Finetuning      | [![Open In Colab](https://colab.research.google.com/assets/colab-badge.svg)](https://colab.research.google.com/github/sony/nnabla/blob/master/tutorial/model_finetuning.ipynb) | [read](https://nnabla.readthedocs.io/en/latest/python/tutorial/model_finetuning.html) |
| Debugging      | [![Open In Colab](https://colab.research.google.com/assets/colab-badge.svg)](https://colab.research.google.com/github/sony/nnabla/blob/master/tutorial/debugging.ipynb) | [read](https://nnabla.readthedocs.io/en/latest/python/tutorial/debugging.html) |
| Static vs. Dynamic Neural Network in NNabla      | [![Open In Colab](https://colab.research.google.com/assets/colab-badge.svg)](https://colab.research.google.com/github/sony/nnabla/blob/master/tutorial/dynamic_and_static_nn.ipynb) | [read](https://nnabla.readthedocs.io/en/latest/python/tutorial/dynamic_and_static_nn.html) |
| Image Generation with DCGAN     | [![Open In Colab](https://colab.research.google.com/assets/colab-badge.svg)](https://colab.research.google.com/github/sony/nnabla/blob/master/tutorial/dcgan_image_generation.ipynb) | Coming Soon |
| Semi-Supervised Learning with VAT     | [![Open In Colab](https://colab.research.google.com/assets/colab-badge.svg)](https://colab.research.google.com/github/sony/nnabla/blob/master/tutorial/vat_semi_supervised_learning.ipynb) | Coming Soon |
| Unsupervised Learning with VAE     | [![Open In Colab](https://colab.research.google.com/assets/colab-badge.svg)](https://colab.research.google.com/github/sony/nnabla/blob/master/tutorial/vae_unsupervised_learning.ipynb) | Coming Soon |
| Feature Embedding with SiameseNet    | [![Open In Colab](https://colab.research.google.com/assets/colab-badge.svg)](https://colab.research.google.com/github/sony/nnabla/blob/master/tutorial/siamese_feature_embedding.ipynb) | Coming Soon |
| Mixed Precision Training      |  | [read](https://nnabla.readthedocs.io/en/latest/python/tutorial/mixed_precision_training.html) |
| Data Parallel Distributed Training      |  | [read](https://nnabla.readthedocs.io/en/latest/python/tutorial/multi_device_training.html) |
| Graph Converter for Inference      |  | [read](https://nnabla.readthedocs.io/en/latest/python/tutorial/graph_converter_for_inference.html) |
